if not Watcher then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants

Watcher:addicon("Plague Strike", 45462)
Watcher:addicon("Moonfire", 8921)
Watcher:addicon("Beast Lore", 1462)
Watcher:addicon("Arcane Intellect", 1459)
Watcher:addicon("Blessing of Might", 19740)
Watcher:addicon("Fortitude", 21562)
Watcher:addicon("Sinister Strike", 1752)
Watcher:addicon("Lightning Shield", 324)
Watcher:addicon("Corruption", 172)
Watcher:addicon("Heroic Strike", 78)
Watcher:addicon("Symbiosis",110500)

if select(2, UnitClass('player')) == "DEATHKNIGHT" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Plague Strike Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Plague Strike"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft, optionnum)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end  
end
	
if select(2, UnitClass('player')) == "DRUID" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Moonfire Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Moonfire"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end 
end

if select(2, UnitClass('player')) == "HUNTER" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Beast Lore Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Beast Lore"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end 
end

if select(2, UnitClass('player')) == "MAGE" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Arcane Intellect Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Arcane Intellect"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end  
end
	
if select(2, UnitClass('player')) == "PALADIN" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Blessing of Might Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Blessing of Might"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end
end

if select(2, UnitClass('player')) == "PRIEST" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Fortitude Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Fortitude"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)

		end
	end  
end
	
if select(2, UnitClass('player')) == "ROGUE" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Sinister Strike Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Sinister Strike"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end 
end

if select(2, UnitClass('player')) == "SHAMAN" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Lightning Shield Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Lightning Shield"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)

		end
	end  
end
	
if select(2, UnitClass('player')) == "WARLOCK" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Corruption Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Corruption"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then
			FrameName:SetAlpha(0)
		end
	end  
end

if select(2, UnitClass('player')) == "WARRIOR" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Heroic Strike Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Heroic Strike"])
		if duration == nil  or start == nil then
		duration = 0
		start = 0
		end
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then

			FrameName:SetAlpha(0)
		end
	end 
end

if select(2, UnitClass('player')) == "WARRIOR" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Heroic Strike Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Heroic Strike"])
		if duration == nil  or start == nil then
		duration = 0
		start = 0
		end
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then

			FrameName:SetAlpha(0)
		end
	end 
end



if select(2, UnitClass('player')) == "MONK" then 
	Watcher.priorityTable.name["gcd"] = "GCD"
	Watcher.priorityTable.icon["gcd"] = C["Symbiosis Icon"]
	Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Symbiosis"])
		if duration == nil  or start == nil then
		duration = 0
		start = 0
		end
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveGCD(FrameName, timeleft)
			return
		end
		if start == 0 then

			FrameName:SetAlpha(0)
		end
	end 
end